%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                              PSG Type    PSG Object                     Location in Problem Statement                               Class
%matrix_artificial_scenarios_data    data        matrix_artificial_scenarios    variance(matrix_artificial_scenarios)                       double
%                                                                               +avg_g(matrix_artificial_scenarios)
%matrix_artificial_scenarios_vars    vars        matrix_artificial_scenarios    variance(matrix_artificial_scenarios)                       cell
%                                                                               +avg_g(matrix_artificial_scenarios)
%matrix_linear_data                  data        matrix_linear                  1.0001*linear(matrix_linear)                                double
%                                                                               -0.0001*linear(matrix_linear)
%matrix_linear_vars                  vars        matrix_linear                  1.0001*linear(matrix_linear)                                cell
%                                                                               -0.0001*linear(matrix_linear)
%matrix_linear_card_data             data        matrix_linear_card             +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)      double
%                                                                               -0.0001*cardn_pos(parameter_alpha_1, matrix_linear_card)
%matrix_linear_card_vars             vars        matrix_linear_card             +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)      cell
%                                                                               -0.0001*cardn_pos(parameter_alpha_1, matrix_linear_card)
%matrix_probability_data             data        matrix_probability             pr_pen(parameter_alpha_2,matrix_probability)                double
%matrix_probability_vars             vars        matrix_probability             pr_pen(parameter_alpha_2,matrix_probability)                cell
%parameter_bound_data                data        parameter_bound                Constraint: <= parameter_bound                              double
%parameter_alpha_data                data        parameter_alpha                +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)      double
%parameter_bound_1_data              data        parameter_bound_1              Constraint: >= parameter_bound_1                            double
%parameter_alpha_1_data              data        parameter_alpha_1              -0.0001*cardn_pos(parameter_alpha_1, matrix_linear_card)    double
%parameter_bound_2_data              data        parameter_bound_2              Constraint: <= parameter_bound_2                            double
%parameter_alpha_2_data              data        parameter_alpha_2              pr_pen(parameter_alpha_2,matrix_probability)                double
%parameter_bound_3_data              data        parameter_bound_3              Box: >= parameter_bound_3, <= parameter_bound_4             double
%parameter_bound_4_data              data        parameter_bound_4              Box: >= parameter_bound_3, <= parameter_bound_4             double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_artificial_scenarios_data,matrix_artificial_scenarios_vars,matrix_linear_data,matrix_linear_vars,matrix_linear_card_data,matrix_linear_card_vars,matrix_probability_data,matrix_probability_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data,parameter_alpha_1_data,parameter_bound_2_data,parameter_alpha_2_data,parameter_bound_3_data,parameter_bound_4_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_artificial_scenarios',matrix_artificial_scenarios_data,matrix_artificial_scenarios_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_linear',matrix_linear_data,matrix_linear_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_linear_card',matrix_linear_card_data,matrix_linear_card_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_probability',matrix_probability_data,matrix_probability_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  variance(matrix_artificial_scenarios)',...
'Constraint: <= parameter_bound',...
'  1.0001*linear(matrix_linear)',...
'  +0.0001*cardn_pos(parameter_alpha, matrix_linear_card)',...
'Constraint: >= parameter_bound_1',...
'  -0.0001*linear(matrix_linear)',...
'  +avg_g(matrix_artificial_scenarios)',...
'  -0.0001*cardn_pos(parameter_alpha_1, matrix_linear_card)',...
'Constraint: <= parameter_bound_2',...
'  pr_pen(parameter_alpha_2,matrix_probability)',...
'Box: >= parameter_bound_3, <= parameter_bound_4',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_alpha_1',num2str(parameter_alpha_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_alpha_2',num2str(parameter_alpha_2_data));
problem_statement = strrep(problem_statement,'parameter_bound_3',num2str(parameter_bound_3_data));
problem_statement = strrep(problem_statement,'parameter_bound_4',num2str(parameter_bound_4_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

